#ifndef SBK_KTOOLBARSPACERACTIONWRAPPER_H
#define SBK_KTOOLBARSPACERACTIONWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <ktoolbarspaceraction.h>

#include <sbkpython.h>

#include <array>
namespace Shiboken { struct AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class KToolBarSpacerActionWrapper : public KToolBarSpacerAction
{
public:
    KToolBarSpacerActionWrapper(::QObject * parent);
    KToolBarSpacerActionWrapper(const KToolBarSpacerActionWrapper &) = delete;
    KToolBarSpacerActionWrapper& operator=(const KToolBarSpacerActionWrapper &) = delete;
    KToolBarSpacerActionWrapper(KToolBarSpacerActionWrapper &&) = delete;
    KToolBarSpacerActionWrapper& operator=(KToolBarSpacerActionWrapper &&) = delete;
    ~KToolBarSpacerActionWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QWidget * createWidget(::QWidget * parent) override;
    static ::QWidget * sbk_o_createWidget([[maybe_unused]] const char *ownerClassName, [[maybe_unused]] const char *funcName, [[maybe_unused]] Shiboken::GilState &gil, [[maybe_unused]] const Shiboken::AutoDecRef &pyOverride, [[maybe_unused]] ::QWidget * parent);
    void customEvent(::QEvent * event) override;
    void deleteWidget(::QWidget * widget) override;
    static void sbk_o_deleteWidget([[maybe_unused]] const char *ownerClassName, [[maybe_unused]] const char *funcName, [[maybe_unused]] Shiboken::GilState &gil, [[maybe_unused]] const Shiboken::AutoDecRef &pyOverride, [[maybe_unused]] ::QWidget * widget);
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * arg__1, ::QEvent * arg__2) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable std::array<PyObject *, 9> m_PyMethodCache = {nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr};
};

#endif // SBK_KTOOLBARSPACERACTIONWRAPPER_H
